<?php
/**
 * Joomla! 1.5 component Cu3er
 *
 * @version $Id: cu3erxml.class.php 2011-04-12 05:17:53 svn $
 * @author Tibor Németh
 * @package Joomla
 * @subpackage Cu3er
 * @license GNU/GPL
 *
 * Cu3er component for Joomla 1.5
 *
 * This component file was created using the Joomla Component Creator by Not Web Design
 * http://www.notwebdesign.com/joomla_component_creator/
 *
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

class Cu3erXML {

	// The destiantion array of Cu3erXMLConv::XML2Array method
	var $xml_array = array();

	// The database array for database queries
	var $db_array = array();
	
	// ID of the processed slideshow
	var $slideshow_id = null;

	// Array for generated Cu3er XML
	var $XMLNodeArray = null;

	// The array containing the dimensions of slideshow
	var $dimensions = null;

	var $cu3er_config_XML = null;

	/**
	 * CU3ERXML constructor
	 */
	function Cu3erXML($slideshow_id) {
	
		$this->slideshow_id = $slideshow_id;

	}

	/**
	 * Slideshow dimension getter method
	 *
	 * @param string  $dim name of the property (width/height)
	 * @return string value of the property
	 */
	function getDimensions($dim) {

		// if XML contains width/height		
		if (isset($this->xml_array['data']['project_settings'][$dim]['value'])) {

			return $this->xml_array['data']['project_settings'][$dim]['value'];

		// if dimensions were asked previously
		} elseif (is_array($this->dimensions)) {

			return $this->dimensions[$dim];

		} else {

			// opening embed_example.html file
			$file_content = JFile::read(JPATH_COMPONENT_SITE.DS.'slideshows'.DS.$this->slideshow_id.DS.'embed_example.html');

			if ($file_content) {

				// extracting dimensions with regexp from embed_example.html
				preg_match_all('/swfobject\.embedSWF\((.*?)\)/', $file_content, $values);
				$dimensions = explode(",", $values[1][0]);
				$this->dimensions['width'] = $dimensions[2];
				$this->dimensions['height'] = $dimensions[3];
				return $this->dimensions[$dim];

			} else {

				// setting dimensions accordint to the slide attributes
				$this->dimensions['width'] = $this->db_array['slides']['attr']['width'];
				$this->dimensions['height'] = $this->db_array['slides']['attr']['height'];
				return $this->dimensions[$dim];
			}
		}
	}

	/**
	 * CU3ER table data getter method
	 *
	 * @param int 		$cid	slideshow_id
	 * @param string	$table	name of the table (default is null, all tables)
	 * @param string	$field	name of the SELECT field (default is *)
	 * @return string value of the property
	 */
	function getDBData($cid, $table = null, $field = null) {
	
		$db = & JFactory::getDBO();

		$rows = null;		

		// if $table is set
		if ($table != null) {
			// setting SELECT fields
			$field = (!is_null($field))?'*':$field;
			// setting WHERE field
			$key = ($table == 'slideshows')?'id':'slideshow_id';					
			// query string
			$query = "SELECT {$field} FROM #__cu3er__{$table} WHERE {$key} = {$cid}";
			// getting query result
			$rows = ($table == 'slides')?$db->loadAssocList():$db->loadAssoc();		
		
		} else {		
			// query strings
			$query_set = "SELECT * FROM #__cu3er__settings WHERE id = 1";
			$query_sl = "SELECT * FROM #__cu3er__slideshows WHERE id = {$cid}";
			$query_def = "SELECT * FROM #__cu3er__defaults WHERE slideshow_id = {$cid}";
			$query_ss = "SELECT * FROM #__cu3er__slides WHERE slideshow_id = {$cid} ORDER BY ordering";

			// getting query results
			$db->setQuery($query_set);
			$rows['settings'] = $db->loadAssoc();

			$db->setQuery($query_sl);
			$rows['slideshow'] = $db->loadAssoc();

			$db->setQuery($query_def);
			$rows['default'] = $db->loadAssoc();

			$db->setQuery($query_ss);
			$rows['slides'] = $db->loadAssocList('id');

		}

		return $rows;
	}

	/**
	 * DB Array setter method
	 *
	 * @param boolean $update true if task is XML update
	 */
	function setDBArray($update) {
		$xml_URL = JRequest::getVar('url');		
		$xml_name = (!is_null($xml_URL))?basename($url):'CU3ER-config.xml';	
		$urlFolderPath = false;

		if($this->isHttp($this->xml_array['data']['settings']['folder_images']['value'])) {
			$urlFolderPath = true;
		}
		$this->db_array['slideshows'] = array(
					'width' => $this->getDimensions('width'),
					'height' => $this->getDimensions('height'),
					'background' => $this->xml_array['data']['settings']['background']['color']['value'],
					'backgroundType' => ($this->xml_array['data']['settings']['background']['color']['attr']['transparent'] == 'true') ? 'transparent' : 'color',
					'bg_image' => $this->xml_array['data']['settings']['background']['image']['url']['value'],
					'bg_use_image' => $this->xml_array['data']['settings']['background']['image']['attr']['use_image'],
					'bg_align_to' => $this->xml_array['data']['settings']['background']['image']['attr']['align_to'],
					'bg_align_pos' => $this->xml_array['data']['settings']['background']['image']['attr']['align_pos'],
					'bg_x' => $this->xml_array['data']['settings']['background']['image']['attr']['x'],
					'bg_y' => $this->xml_array['data']['settings']['background']['image']['attr']['y'],
					'bg_scaleX' => $this->xml_array['data']['settings']['background']['image']['attr']['scaleX'],
					'bg_scaleY' => $this->xml_array['data']['settings']['background']['image']['attr']['scaleY'],
					'sdw_show' => $this->xml_array['data']['settings']['shadow']['attr']['show'],
					'sdw_use_image' => $this->xml_array['data']['settings']['shadow']['attr']['use_image'],
					'sdw_image' => $this->xml_array['data']['settings']['shadow']['url']['value'],
					'sdw_color' => $this->xml_array['data']['settings']['shadow']['attr']['color'],
					'sdw_alpha' => $this->xml_array['data']['settings']['shadow']['attr']['alpha'],
					'sdw_blur' => $this->xml_array['data']['settings']['shadow']['attr']['blur'],
					'sdw_corner_tl' => $this->xml_array['data']['settings']['shadow']['attr']['corner_TL'],
					'sdw_corner_tr' => $this->xml_array['data']['settings']['shadow']['attr']['corner_TR'],
					'sdw_corner_bl' => $this->xml_array['data']['settings']['shadow']['attr']['corner_BL'],
					'sdw_corner_br' => $this->xml_array['data']['settings']['shadow']['attr']['corner_BR'],
					'pr_image' => $this->xml_array['data']['preloader']['image']['url']['value'],
					'pr_align_to' => $this->xml_array['data']['preloader']['image']['attr']['align_to'],
					'pr_align_pos' => $this->xml_array['data']['preloader']['image']['attr']['align_pos'],
					'pr_x' => $this->xml_array['data']['preloader']['image']['attr']['x'],
					'pr_y' => $this->xml_array['data']['preloader']['image']['attr']['y'],
					'pr_scaleX' => ($this->xml_array['data']['preloader']['image']['attr']['scaleX'] != '') ? $this->xml_array['data']['preloader']['image']['attr']['scaleX'] : 1,
					'pr_scaleY' => ($this->xml_array['data']['preloader']['image']['attr']['scaleY'] != '') ? $this->xml_array['data']['preloader']['image']['attr']['scaleY'] : 1,
					'pr_loader_direction' => $this->xml_array['data']['preloader']['image']['attr']['loader_direction'],
					'pr_alpha_loader' => $this->xml_array['data']['preloader']['image']['attr']['alpha_loader'],
					'pr_alpha_bg' => $this->xml_array['data']['preloader']['image']['attr']['alpha_bg'],
					'pr_tint_loader' => $this->xml_array['data']['preloader']['image']['attr']['tint_loader'],
					'pr_tint_bg' => $this->xml_array['data']['preloader']['image']['attr']['tint_bg'],
					'pr_width' => $this->xml_array['data']['preloader']['image']['attr']['width'],
					'pr_height' => $this->xml_array['data']['preloader']['image']['attr']['height'],
					'images_folder' => null,
					'fonts_folder' => null,
					'xml_location' => $this->cu3er_config_XML,
					'modified' => date('Y-n-d H:i:s'),
					/* 20110710 Update */
					'br_align_to' => $this->xml_array['data']['settings']['branding']['attr']['align_to'],
					'br_align_pos' => $this->xml_array['data']['settings']['branding']['attr']['align_pos'],
					'br_x' => $this->xml_array['data']['settings']['branding']['attr']['x'],
					'br_y' => $this->xml_array['data']['settings']['branding']['attr']['y'],
					'content' => ($this->xml_array['data']['settings']['content'])?$this->xml_array['data']['settings']['content']:(JText::_('COM_CU3ER_ALT_CONTENT')),
					);
		
		$this->db_array['defaults'] = array(
					'slideshow_id' => null,
					'duration' => ($this->xml_array['data']['defaults']['slide']['attr']['time'] > 0) ? $this->xml_array['data']['defaults']['slide']['attr']['time'] : '',
					'color' => $this->xml_array['data']['defaults']['slide']['attr']['color'],
					'link' => $this->xml_array['data']['defaults']['slide']['link']['value'],
					'target' => $this->xml_array['data']['defaults']['slide']['link']['attr']['target'],
					'dlink' => $this->xml_array['data']['defaults']['slide']['description']['link']['value'],
					'dtarget' => $this->xml_array['data']['defaults']['slide']['description']['link']['attr']['target'],
					'align_pos' => $this->xml_array['data']['defaults']['slide']['image']['attr']['align_pos'],
					'x' => $this->xml_array['data']['defaults']['slide']['image']['attr']['x'],
					'y' => $this->xml_array['data']['defaults']['slide']['image']['attr']['y'],
					'scaleX' => $this->xml_array['data']['defaults']['slide']['image']['attr']['scaleX'],
					'scaleY' => $this->xml_array['data']['defaults']['slide']['image']['attr']['scaleY'],
					'type' => $this->xml_array['data']['defaults']['transition']['attr']['type'],
					'columns' => ($this->xml_array['data']['defaults']['transition']['attr']['columns'] > 0) ? $this->xml_array['data']['defaults']['transition']['attr']['columns'] : '',
					'rows' => ($this->xml_array['data']['defaults']['transition']['attr']['rows'] > 0) ? $this->xml_array['data']['defaults']['transition']['attr']['rows'] : '',
					'type2D' => $this->xml_array['data']['defaults']['transition']['attr']['type2D'],
					'flipAngle' => $this->xml_array['data']['defaults']['transition']['attr']['flipAngle'],
					'flipOrder' => $this->xml_array['data']['defaults']['transition']['attr']['flipOrder'],
					'flipShader' => $this->xml_array['data']['defaults']['transition']['attr']['flipShader'],
					'flipOrderFromCenter' => $this->xml_array['data']['defaults']['transition']['attr']['flipOrderFromCenter'],
					'flipDirection' => $this->xml_array['data']['defaults']['transition']['attr']['flipDirection'],
					'flipColor' => $this->xml_array['data']['defaults']['transition']['attr']['flipColor'],
					'flipBoxDepth' => $this->xml_array['data']['defaults']['transition']['attr']['flipBoxDepth'],
					'flipDepth' => $this->xml_array['data']['defaults']['transition']['attr']['flipDepth'],
					'flipEasing' => $this->xml_array['data']['defaults']['transition']['attr']['flipEasing'],
					'flipDuration' => $this->xml_array['data']['defaults']['transition']['attr']['flipDuration'],
					'flipDelay' => $this->xml_array['data']['defaults']['transition']['attr']['flipDelay'],
					'flipDelayRandomize' => $this->xml_array['data']['defaults']['transition']['attr']['flipDelayRandomize'],
					'salign_pos' => $this->xml_array['data']['slides']['attr']['align_pos'],
					'sx' => $this->xml_array['data']['slides']['attr']['x'],
					'sy' => $this->xml_array['data']['slides']['attr']['y'],
					'swidth' => $this->xml_array['data']['slides']['attr']['width'],
					'sheight' => $this->xml_array['data']['slides']['attr']['height'],
					/* 20110710 Update */
					'corner_TL' => $this->xml_array['data']['slides']['attr']['corner_TL'],	
					'corner_TR' => $this->xml_array['data']['slides']['attr']['corner_TR'],	
					'corner_BL' => $this->xml_array['data']['slides']['attr']['corner_BL'],	
					'corner_BR' => $this->xml_array['data']['slides']['attr']['corner_BR'],	
					'thumb_width' => $this->xml_array['data']['thumbnails']['thumb']['image']['attr']['width'],
					'thumb_height' => $this->xml_array['data']['thumbnails']['thumb']['image']['attr']['height'],
					'transparent' => $this->xml_array['data']['defaults']['slide']['attr']['transparent']
				);
			if(is_array($this->xml_array['data']['defaults']['slide']['seo'])) {
				$this->db_array['defaults']['seo_show_image'] = ($this->xml_array['data']['defaults']['slide']['seo']['show']['attr']['image'] == 'true') ? 'yes' : 'no';
				$this->db_array['defaults']['seo_show_heading'] = ($this->xml_array['data']['defaults']['slide']['seo']['show']['attr']['heading'] == 'true') ? 'yes' : 'no';
				$this->db_array['defaults']['seo_show_paragraph'] = ($this->xml_array['data']['defaults']['slide']['seo']['show']['attr']['paragraph'] == 'true') ? 'yes' : 'no';
				$this->db_array['defaults']['seo_show_caption'] = ($this->xml_array['data']['defaults']['slide']['seo']['show']['attr']['caption'] == 'true') ? 'yes' : 'no';
			}
							

		// if task is not XML update		
		if (!$update) {

			foreach($this->xml_array['data']['slides']['slide'] as $key => $value) {

				if (is_numeric($key)) {
					$slide = &$this->xml_array['data']['slides']['slide'][$key];
				} else {
					$slide = &$this->xml_array['data']['slides']['slide'];
					$key = 0;
				}

				$dlink = &$slide['description']['link'];

				if (isset($dlink) && isset($dlink['attr']) && isset($dlink['attr']['target'])) {
					$dtarget = $dlink['attr']['target'];
				} else {
					$dtarget = '';
				}
	
				if($this->isHttp($slide['url']['value'])) {
					$image = $slide['url']['value'];
				} elseif ($urlFolderPath) {
					$image = $this->xml_array['data']['settings']['folder_images']['value'] . $slide['url']['value'];
				} else {
					$image = $slide['url']['value'];			
				}
				
				if(is_array($this->xml_array['data']['slides']['slide'][$key]['seo'])) {
					$seo_show_image = ($this->xml_array['data']['slides']['slide'][$key]['seo']['show']['attr']['image'] == 'true') ? 'yes' : 'no';
					$seo_show_heading = ($this->xml_array['data']['slides']['slide'][$key]['seo']['show']['attr']['heading'] == 'true') ? 'yes' : 'no';
					$seo_show_paragraph = ($this->xml_array['data']['slides']['slide'][$key]['seo']['show']['attr']['paragraph'] == 'true') ? 'yes' : 'no';
					$seo_show_caption = ($this->xml_array['data']['slides']['slide'][$key]['seo']['show']['attr']['caption'] == 'true') ? 'yes' : 'no';
					$seo_text = ($this->xml_array['data']['slides']['slide'][$key]['seo']['text']['value'] != '') ? $this->xml_array['data']['slides']['slide'][$key]['seo']['text']['value'] : '';
					$seo_img_alt = ($this->xml_array['data']['slides']['slide'][$key]['seo']['img_alt']['value'] != '') ? $this->xml_array['data']['slides']['slide'][$key]['seo']['img_alt']['value'] : '';
				}
	
				$this->db_array['slides'][$key] = array(
					'slideshow_id' => null,
					'image' => $image,
					'use_image' => ($slide['attr']['use_image'] == 'false') ? 'no' : 'yes',
					'duration' => $slide['attr']['time'],
					'caption' => $slide['caption']['value'],
					'color' => $slide['attr']['color'],
					'link' => $slide['link']['value'],
					'target' => (array_key_exists('attr', $slide['link']))?$slide['link']['attr']['target']:'',
					'align_pos' => $slide['image']['attr']['align_pos'],
					'x' => $slide['image']['attr']['x'],
					'y' => $slide['image']['attr']['y'],
					'scaleX' => $slide['image']['attr']['scaleX'],
					'scaleY' => $slide['image']['attr']['scaleY'],
					'transparent' => $slide['attr']['transparent'],
					'heading' => (array_key_exists('value', $slide['description']['heading'])) ? $slide['description']['heading']['value'] : '',
					'paragraph' => (array_key_exists('value', $slide['description']['paragraph'])) ? $slide['description']['paragraph']['value'] : '',
					'dlink' => (array_key_exists('value', $dlink)) ? ($dlink['value']) : '',
					'dtarget' => $dtarget,
					'position' => $key,
					'ordering' => $key,
					'published' => 1,
					'seo_show_image' => $seo_show_image,
					'seo_show_heading' => $seo_show_heading,
					'seo_show_paragraph' => $seo_show_paragraph,
					'seo_show_caption' => $seo_show_caption,
					'seo_text' => $seo_text,
					'seo_img_alt' => $seo_img_alt
				);
				unset($seo_show_image, $seo_show_heading, $seo_show_paragraph, $seo_show_caption, $seo_text, $seo_img_alt);

				// setting of slide transitions			
				foreach ($this->xml_array['data']['slides']['transition'][$key]['attr'] as $_key => $_value) {
					if (isset($_key)) {
						$this->db_array['slides'][$key][$_key] = $_value;
					}
				}
			}
		}
	}

	/**
	 * XML file loader method
	 *
	 * @param string	$file	name of the XML file
	 * @param boolean	$update true if task is XML update
	 */	
	function loadXMLFile($file, $update = false) {
	
		require_once(JPATH_COMPONENT.DS.'lib'.DS.'cu3erxmlconv.class.php');
		jimport('joomla.filesystem.file');

		// getting XML string from file
		$xml_str = preg_replace('/\<transition(.*?)\>/', '<transition empty="true"$1>', JFile::read($file));

		$this->cu3er_config_XML = basename($file);

		// instantiatig Cu3erXMLConv class
		$XMLConv = new Cu3erXMLConv($xml_str);

		// setting $xml_array property by XML2Array method
		$this->xml_array = $XMLConv->XML2Array();

		// setting $db_array property
		$this->setDBArray($update);
	}

	/**
	 * XML encoded string generator method
	 *
	 * @param mixed		$slideshow_id ID of the slideshow, false if slideshow is new
	 * @param array		$prev_array array of preview parameters
	 * @return mixed	XML string or false
	 */
	function generateXML($slideshow_id = false, $prev_array = null) {

		require_once(JPATH_COMPONENT.DS.'lib'.DS.'cu3erxmlconv.class.php');
		// setting $XMLNodeArray property from getDBData method
		$this->XMLNodeArray = $this->getDBData((!$slideshow_id)?$this->slideshow_id:$slideshow_id);
		
		// replacing values from database with preview parameter values	
		if ($prev_array !== null) {		

			foreach($prev_array['params'] as $name => $value) {
				if (isset($prev_array['key'])) {
					$this->XMLNodeArray[$prev_array['name']][$prev_array['key']][$name] = $value;
				} else {
					$this->XMLNodeArray[$prev_array['name']][$name] = $value;
				}
			}
		}
		
		// generating XMLNodeArray		
		$xml_data['data'] = $this->setXMLNodeArray();

		if ($xml_data['data']) {
			// generating XML encoded string			
			return Cu3erXMLConv::array2XML($xml_data);
		} else {
			return false;		
		}
	}

	/**
	 * XML node array setter method
	 *
	 * @return array XML array
	 */
	function setXMLNodeArray() {

		$data = &$this->XMLNodeArray;

		$arrXML = array();

		$cu3erURL = JURI::root().'components'.DS.'com_cu3er'.DS;

		if($data['settings']['licence'] != '') {
			$arrXML[0]['licence'] = "<![CDATA[" .stripslashes(trim($data['settings']['licence'])). "]]>";
		}
		if($data['settings']['licence1'] != '') {
			$arrXML[1]['licence'] = "<![CDATA[" .stripslashes(trim($data['settings']['licence1'])). "]]>";
		}
		if($data['settings']['licence2'] != '') {
			$arrXML[2]['licence'] = "<![CDATA[" .stripslashes(trim($data['settings']['licence2'])). "]]>";
		}
		if($data['settings']['licence3'] != '') {
			$arrXML[3]['licence'] = "<![CDATA[" .stripslashes(trim($data['settings']['licence3'])). "]]>";
		}
		if($data['settings']['licence4'] != '') {
			$arrXML[4]['licence'] = "<![CDATA[" .stripslashes(trim($data['settings']['licence4'])). "]]>";
		}

		// 20110710 Update
		if($data['settings']['branding'] == 'yes') {
			$arrXML['settings']['branding']['remove_logo_loader'] = 'true';
			$arrXML['settings']['branding']['remove_right_menu_info'] = 'true';
			$arrXML['settings']['branding']['remove_right_menu_licence'] = 'true';
		}

		$arrXML['project_settings']['width'] = $data['slideshow']['width'];
		$arrXML['project_settings']['height'] = $data['slideshow']['height'];

		$arrXML['settings']['published'] = $data['slideshow']['published'];
		$arrXML['settings']['content'] = $data['slideshow']['content'];
		// 20110728 Update
		$arrXML['settings']['force_js'] = $data['slideshow']['force_js'];
		$arrXML['settings']['xml_location'] = $data['slideshow']['xml_location'];

		$arrXML['settings']['background']['color']['vle'] = str_replace(array('#','0X'), array('0x','0x'), $data['slideshow']['background']);
		$arrXML['settings']['background']['color']['@attributes']['transparent'] = ($data['slideshow']['backgroundType'] == 'transparent') ? 'true' : 'false';
		$arrXML['settings']['background']['image']['url'] = "<![CDATA[" . $data['slideshow']['bg_image'] . "]]>";

		if($arrXML['settings']['background']['image']['url'] == '<![CDATA[]]>') {
			$arrXML['settings']['background']['image']['url'] = '';
		}

		$arrXML['settings']['background']['image']['@attributes']['use_image'] = $data['slideshow']['bg_use_image'];
		$arrXML['settings']['background']['image']['@attributes']['align_to'] = $data['slideshow']['bg_align_to'];
		$arrXML['settings']['background']['image']['@attributes']['align_pos'] = $data['slideshow']['bg_align_pos'];
		$arrXML['settings']['background']['image']['@attributes']['x'] = $data['slideshow']['bg_x'];
		$arrXML['settings']['background']['image']['@attributes']['y'] = $data['slideshow']['bg_y'];
		$arrXML['settings']['background']['image']['@attributes']['scaleX'] = $data['slideshow']['bg_scaleX'];
		$arrXML['settings']['background']['image']['@attributes']['scaleY'] = $data['slideshow']['bg_scaleY'];
		$arrXML['settings']['folder_images'] = $data['slideshow']['images_folder'];

		if($data['slideshow']['sdw_use_image'] == 'true' && $data['slideshow']['sdw_image'] != '') {
			$arrXML['settings']['shadow']['@attributes']['use_image'] = $data['slideshow']['sdw_use_image'];
			$arrXML['settings']['shadow']['@attributes']['show'] = $data['slideshow']['sdw_show'];
			$arrXML['settings']['shadow']['@attributes']['color'] = str_replace(array('#','0X'), array('0x','0x'), $data['slideshow']['sdw_color']);
			$arrXML['settings']['shadow']['@attributes']['alpha'] = $data['slideshow']['sdw_alpha'];
			$arrXML['settings']['shadow']['@attributes']['blur'] = $data['slideshow']['sdw_blur'];
			$arrXML['settings']['shadow']['@attributes']['corner_TL'] = $data['slideshow']['sdw_corner_tl'];
			$arrXML['settings']['shadow']['@attributes']['corner_TR'] = $data['slideshow']['sdw_corner_tr'];
			$arrXML['settings']['shadow']['@attributes']['corner_BL'] = $data['slideshow']['sdw_corner_bl'];
			$arrXML['settings']['shadow']['@attributes']['corner_BR'] = $data['slideshow']['sdw_corner_br'];
			$arrXML['settings']['shadow']['url'] = $data['slideshow']['sdw_image'];
		}

		if($arrXML['settings']['folder_images'] == '<![CDATA[]]>') {
			$arrXML['settings']['folder_images'] = '';
		} 

		$arrXML['settings']['folder_fonts'] = $data['slideshow']['fonts_folder'];
		if($arrXML['settings']['folder_fonts'] == '<![CDATA[]]>') {
			$arrXML['settings']['folder_fonts'] = '';
		}

		// 20110710 Update
		$arrXML['settings']['branding']['@attributes']['align_to'] = $data['slideshow']['br_align_to'];
		$arrXML['settings']['branding']['@attributes']['align_pos'] = $data['slideshow']['br_align_pos'];
		$arrXML['settings']['branding']['@attributes']['x'] = $data['slideshow']['br_x'];
		$arrXML['settings']['branding']['@attributes']['y'] = $data['slideshow']['br_y'];

		if($data['slideshow']['pr_image'] != '') {
			$arrXML['preloader']['image']['@attributes']['align_to'] = $data['slideshow']['pr_align_to'];
			$arrXML['preloader']['image']['@attributes']['width'] = $data['slideshow']['pr_width'];
			$arrXML['preloader']['image']['@attributes']['height'] = $data['slideshow']['pr_height'];
			$arrXML['preloader']['image']['@attributes']['align_pos'] = $data['slideshow']['pr_align_pos'];
			$arrXML['preloader']['image']['@attributes']['x'] = $data['slideshow']['pr_x'];
			$arrXML['preloader']['image']['@attributes']['y'] = $data['slideshow']['pr_y'];
			$arrXML['preloader']['image']['@attributes']['scaleX'] = ($data['slideshow']['pr_scaleX'] != '') ? $data['slideshow']['pr_scaleX'] : 1;
			$arrXML['preloader']['image']['@attributes']['scaleY'] = ($data['slideshow']['pr_scaleY'] != '') ? $data['slideshow']['pr_scaleY'] : 1;
			$arrXML['preloader']['image']['@attributes']['loader_direction'] = $data['slideshow']['pr_loader_direction'];
			$arrXML['preloader']['image']['@attributes']['alpha_loader'] = $data['slideshow']['pr_alpha_loader'];
			$arrXML['preloader']['image']['@attributes']['alpha_bg'] = $data['slideshow']['pr_alpha_bg'];
			$arrXML['preloader']['image']['@attributes']['tint_loader'] = $data['slideshow']['pr_tint_loader'];
			$arrXML['preloader']['image']['@attributes']['tint_bg '] = $data['slideshow']['pr_tint_bg '];
			$arrXML['preloader']['image']['url'] = $data['slideshow']['pr_image'];
		}

		$arrXML['defaults']['slide']['@attributes']['time'] = $data['default']['duration'];
		$arrXML['defaults']['slide']['@attributes']['color'] = str_replace(array('#','0X'), array('0x','0x'), $data['default']['color']);
		
		$arrXML['defaults']['slide']['@attributes']['transparent'] = $data['default']['transparent'];
		
		$arrXML['defaults']['slide']['link']['vle'] = "<![CDATA[" .$data['default']['link']. "]]>";

		if($arrXML['defaults']['slide']['link']['vle'] == '<![CDATA[]]>') {
			$arrXML['defaults']['slide']['link']['vle'] = '';
		}

		$arrXML['defaults']['slide']['link']['@attributes']['target'] = $data['default']['target'];

		$arrXML['defaults']['slide']['description']['link']['vle'] = "<![CDATA[" .$data['default']['dlink']. "]]>";

		if($arrXML['defaults']['slide']['description']['link']['vle'] == '<![CDATA[]]>') {
			$arrXML['defaults']['slide']['description']['link']['vle'] = '';
		}

		$arrXML['defaults']['slide']['description']['link']['@attributes']['target'] = $data['default']['dtarget'];
		$arrXML['defaults']['slide']['image']['@attributes']['align_pos'] = $data['default']['align_pos'];
		$arrXML['defaults']['slide']['image']['@attributes']['x'] = $data['default']['x'];
		$arrXML['defaults']['slide']['image']['@attributes']['y'] = $data['default']['y'];
		$arrXML['defaults']['slide']['image']['@attributes']['scaleX'] = $data['default']['scaleX'];
		$arrXML['defaults']['slide']['image']['@attributes']['scaleY'] = $data['default']['scaleY'];
		$arrXML['defaults']['transition']['@attributes']['type'] = $data['default']['type'];
		$arrXML['defaults']['transition']['@attributes']['columns'] = $data['default']['columns'];
		$arrXML['defaults']['transition']['@attributes']['rows'] = $data['default']['rows'];
		$arrXML['defaults']['transition']['@attributes']['type2D'] = $data['default']['type2D'];
		$arrXML['defaults']['transition']['@attributes']['flipAngle'] = $data['default']['flipAngle'];
		$arrXML['defaults']['transition']['@attributes']['flipOrder'] = $data['default']['flipOrder'];
		$arrXML['defaults']['transition']['@attributes']['flipShader'] = $data['default']['flipShader'];
		$arrXML['defaults']['transition']['@attributes']['flipOrderFromCenter'] = $data['default']['flipOrderFromCenter'];
		$arrXML['defaults']['transition']['@attributes']['flipDirection'] = $data['default']['flipDirection'];
		$arrXML['defaults']['transition']['@attributes']['flipColor'] = str_replace(array('#','0X'), array('0x','0x'), $data['default']['flipColor']);
		$arrXML['defaults']['transition']['@attributes']['flipBoxDepth'] = $data['default']['flipBoxDepth'];
		$arrXML['defaults']['transition']['@attributes']['flipDepth'] = $data['default']['flipDepth'];
		$arrXML['defaults']['transition']['@attributes']['flipEasing'] = $data['default']['flipEasing'];
		$arrXML['defaults']['transition']['@attributes']['flipDuration'] = $data['default']['flipDuration'];
		$arrXML['defaults']['transition']['@attributes']['flipDelay'] = $data['default']['flipDelay'];
		$arrXML['defaults']['transition']['@attributes']['flipDelayRandomize'] = $data['default']['flipDelayRandomize'];

		$arrXML['slides']['@attributes']['align_pos'] = $data['default']['salign_pos'];
		$arrXML['slides']['@attributes']['x'] = $data['default']['sx'];
		$arrXML['slides']['@attributes']['y'] = $data['default']['sy'];
		$arrXML['slides']['@attributes']['width'] = $data['default']['swidth'];
		$arrXML['slides']['@attributes']['height'] = $data['default']['sheight'];

		// 20110710 Update
		$arrXML['slides']['@attributes']['corner_TL'] = $data['default']['corner_TL'];
		$arrXML['slides']['@attributes']['corner_TR'] = $data['default']['corner_TR'];
		$arrXML['slides']['@attributes']['corner_BL'] = $data['default']['corner_BL'];
		$arrXML['slides']['@attributes']['corner_BR'] = $data['default']['corner_BR'];
		
		foreach($data['slides'] as $key=>$value) {
			if ($value['published'] == 1) {
				$arrXML['slides'][$key]['slide']['url'] = "<![CDATA[" .(($this->isHttp($value['image'])) ? $value['image'] : $this->removeDomainName($value['image'])). "]]>";

				if($value['duration'] != $data['default']['duration']) {
					$arrXML['slides'][$key]['slide']['@attributes']['time'] = $value['duration'];
				}

				$arrXML['slides'][$key]['slide']['image']['@attributes']['align_pos'] = $value['align_pos'];
				$arrXML['slides'][$key]['slide']['@attributes']['use_image'] = ($value['use_image'] == 'no') ? 'false' : 'true';
				$arrXML['slides'][$key]['slide']['image']['@attributes']['x'] = $value['x'];
				$arrXML['slides'][$key]['slide']['image']['@attributes']['y'] = $value['y'];
				$arrXML['slides'][$key]['slide']['image']['@attributes']['scaleX'] = $value['scaleX'];
				$arrXML['slides'][$key]['slide']['image']['@attributes']['scaleY'] = $value['scaleY'];
				$arrXML['slides'][$key]['slide']['caption'] = "<![CDATA[" .$value['caption']. "]]>";

				if($arrXML['slides'][$key]['slide']['caption'] == '<![CDATA[]]>') {
					$arrXML['slides'][$key]['slide']['caption'] = '';
				}
				if($value['color'] != $data['default']['color']) {
					$arrXML['slides'][$key]['slide']['@attributes']['color'] = str_replace(array('#','0X'), array('0x','0x'), $value['color']);
				}
				if($value['transparent'] != $data['default']['transparent']) {
					$arrXML['slides'][$key]['slide']['@attributes']['transparent'] = $value['transparent'];
				}
				if($value['link'] != $data['default']['link']) {
					$arrXML['slides'][$key]['slide']['link']['vle'] = "<![CDATA[" .$value['link']. "]]>";
				}
				if($arrXML['slides'][$key]['slide']['link']['vle'] == '<![CDATA[]]>') {
					$arrXML['slides'][$key]['slide']['link']['vle'] = '';
				}
				if($value['target'] != $data['default']['target']) {
					$arrXML['slides'][$key]['slide']['link']['@attributes']['target'] = $value['target'];
				}
				$arrXML['slides'][$key]['slide']['description']['heading'] = "<![CDATA[" .$value['heading']. "]]>";
	
				if($arrXML['slides'][$key]['slide']['description']['heading'] == '<![CDATA[]]>') {
					$arrXML['slides'][$key]['slide']['description']['heading'] = '';
				}		
				$arrXML['slides'][$key]['slide']['description']['paragraph'] = "<![CDATA[" .$value['paragraph']. "]]>";
				if($arrXML['slides'][$key]['slide']['description']['paragraph'] == '<![CDATA[]]>') {
					$arrXML['slides'][$key]['slide']['description']['paragraph'] = '';
				}
				if($value['dlink'] != $data['default']['dlink']) {
					$arrXML['slides'][$key]['slide']['description']['link']['vle'] = "<![CDATA[" .$value['dlink']. "]]>";
				}
				if($arrXML['slides'][$key]['slide']['description']['link']['vle'] == '<![CDATA[]]>') {
					$arrXML['slides'][$key]['slide']['description']['link']['vle'] = '';
				}
				if($value['dtarget'] != $data['default']['dtarget']) {
					$arrXML['slides'][$key]['slide']['description']['link']['@attributes']['target'] = $value['dtarget'];
				}
				if($value['type'] != $data['default']['type']) {
					$arrXML['slides'][$key]['transition']['@attributes']['type'] = $value['type'];
				}
				if($value['columns'] != $data['default']['columns']) {
					$arrXML['slides'][$key]['transition']['@attributes']['columns'] = $value['columns'];
				}
				if($value['rows'] != $data['default']['rows']) {
					$arrXML['slides'][$key]['transition']['@attributes']['rows'] = $value['rows'];
				}
				if($value['type2D'] != $data['default']['type2D']) {
					$arrXML['slides'][$key]['transition']['@attributes']['type2D'] = $value['type2D'];
				}
				if($value['flipAngle'] != $data['default']['flipAngle']) {
					$arrXML['slides'][$key]['transition']['@attributes']['flipAngle'] = $value['flipAngle'];
				}
				if($value['flipAngle'] != $data['default']['flipAngle']) {
					$arrXML['slides'][$key]['transition']['@attributes']['flipOrder'] = $value['flipOrder'];
				}
				if($value['flipShader'] != $data['default']['flipShader']) {
					$arrXML['slides'][$key]['transition']['@attributes']['flipShader'] = $value['flipShader'];
				}
				if($value['flipOrderFromCenter'] != $data['default']['flipOrderFromCenter']) {
					$arrXML['slides'][$key]['transition']['@attributes']['flipOrderFromCenter'] = $value['flipOrderFromCenter'];
				}
				if($value['flipDirection'] != $data['default']['flipDirection']) {
					$arrXML['slides'][$key]['transition']['@attributes']['flipDirection'] = $value['flipDirection'];
				}
				if($value['flipColor'] != $data['default']['flipColor']) {
					$arrXML['slides'][$key]['transition']['@attributes']['flipColor'] = str_replace(array('#','0X'), array('0x','0x'), $value['flipColor']);
				}
				if($value['flipBoxDepth'] != $data['default']['flipBoxDepth']) {
					$arrXML['slides'][$key]['transition']['@attributes']['flipBoxDepth'] = $value['flipBoxDepth'];
				}
				if($value['flipDepth'] != $data['default']['flipDepth']) {
					$arrXML['slides'][$key]['transition']['@attributes']['flipDepth'] = $value['flipDepth'];
				}

				if($value['flipEasing'] != $data['default']['flipEasing']) {
					$arrXML['slides'][$key]['transition']['@attributes']['flipEasing'] = $value['flipEasing'];
				}
				if($value['flipDuration'] != $data['default']['flipDuration']) {
					$arrXML['slides'][$key]['transition']['@attributes']['flipDuration'] = $value['flipDuration'];
				}
				if($value['flipDelay'] != $data['default']['flipDelay']) {
					$arrXML['slides'][$key]['transition']['@attributes']['flipDelay'] = $value['flipDelay'];
				}
				if($value['flipDelayRandomize'] != $data['default']['flipDelayRandomize']) {
					$arrXML['slides'][$key]['transition']['@attributes']['flipDelayRandomize'] = $value['flipDelayRandomize'];
				}
			}		
		}
	
		$result_data = $this->arrayRemoveEmpty($arrXML);

		if($data['settings']['licence'] != '') {
			$result_data[0]['licence'] = '<![CDATA['. $data['settings']['licence'] .']]>';
		}
		if($data['settings']['licence1'] != '') {
			$result_data[1]['licence'] = '<![CDATA['. $data['settings']['licence1'] .']]>';
		}
		if($data['settings']['licence2'] != '') {
			$result_data[2]['licence'] = '<![CDATA['. $data['settings']['licence2'] .']]>';
		}
		if($data['settings']['licence3'] != '') {
			$result_data[3]['licence'] = '<![CDATA['. $data['settings']['licence3'] .']]>';
		}
		if($data['settings']['licence4'] != '') {
			$result_data[4]['licence'] = '<![CDATA['. $data['settings']['licence4'] .']]>';
		}
		
		return $result_data;
	}

	/**
	 * Array empty element removal method
	 *
	 * @param array 	$input input array
	 * @return array	cleaned up array
	 */
	function arrayRemoveEmpty($input){
		return $this->cleanUpArray($input);
	}

	/**
	 * Array cleaner method
	 *
	 * @param array		$arr array
	 * @param int		$non_zero_start non zero start state
	 * @return array	new array
	 */	
	function cleanUpArray($arr, $non_zero_start = 0) {
		$main = array('transition', 'slide');
		$new_arr = array();
		foreach ($arr as $key => $value) {
			if (isset($value)) {
				if (is_array($value)) {
					$value = $this->cleanUpArray($value, $non_zero_start);
					// If after the cleaning there are not elements do not bother to add this item
					if (count($value) == 0) {
						if(!in_array($key, $main)) {
							continue;
						} else {
							$new_arr[$key] = $value;
						}
					}
				} else {
					$value = trim($value);
					if(((string)$value == '' || (string)$value == null) && !in_array($key, $main)) {
						continue;
					}
				}
				$new_arr[$key] = $value;
			} else {
				if($value === 0 || in_array($key, $main)) {
					$new_arr[$key] = $value;
				}
			}
		}
		// Reordering elements
		if (!empty($new_arr)) {
			if (!empty($non_zero_start)) {
				$new_arr = array_merge_recursive(array("") + $new_arr);
				unset($new_arr[0]);
			} else {
				$new_arr = array_merge_recursive($new_arr);
			}
		}
		return $new_arr;
	}

	/**
	 * HTTP validator method
	 *
	 * @param string	$url URL string
	 * @return boolean	true if URL is valid http
	 */
	function isHttp($url) {
		$scheme = parse_url($url, PHP_URL_SCHEME);
		return ($scheme != null);
	}

	/**
	 * XML string validator method
	 *
	 * @param string	$xml XML string
	 * @return boolean	true if XML string is a well formed XML
	 */
	function isXML($xml) {
		return (simplexml_load_file($xml));	
	}

	/**
	 * Domain name stripper method method
	 *
	 * @param string	$string URI string
	 * @return boolean	true if stripped successfully
	 */
	function removeDomainName($string) {
		return preg_replace('/http\:\/\/(.*?)\//', '/', $string);
	}

}
?>