<?php
/**
 * @version		$Id: cu3er.php 14401 2010-01-26 14:10:00Z louis $
 * @package		Joomla
 * @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 * Joomla! is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
 * is derivative of works licensed under the GNU General Public License or
 * other free or open source software licenses.
 * See COPYRIGHT.php for copyright notices and details.
 */

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

/**
 * Cu3er Slideshow Insert buton
 *
 * @package Editors-xtd
 * @since 1.5
 */
class plgButtonCu3er extends JPlugin
{
	/**
	 * Constructor
	 *
	 * For php4 compatability we must not use the __constructor as a constructor for plugins
	 * because func_get_args ( void ) returns a copy of all passed arguments NOT references.
	 * This causes problems with cross-referencing necessary for the observer design pattern.
	 *
	 * @param object $subject The object to observe
	 * @param 	array  $config  An array that holds the plugin configuration
	 * @since 1.5
	 */
	function plgButtonCu3er(& $subject, $config)
	{
		parent::__construct($subject, $config);
	}

	/**
	 * Display the button
	 *
	 * @return array A two element array of ( imageName, textToInsert )
	 */
	function onDisplay($name)
	{
		global $mainframe;

		$doc = & JFactory::getDocument();

		$link = 'index.php?option=com_cu3er&amp;view=slideshows&amp;task=editor&amp;tmpl=component&amp;e_name='.$name;

		JHTML::_('behavior.modal');

		$css = ".button2-left .cu3er { " .
			"background: transparent url(../plugins/editors-xtd/cu3er/icon_cu3er.png) no-repeat 100% 0px; " .
			"}";

		$doc->addStyleDeclaration($css);

		$button = new JObject();
		$button->set('modal', true);
		$button->set('link', $link);
		$button->set('text', JText::_('Insert CU3ER'));
		$button->set('name', 'cu3er');
		$button->set('options', "{handler: 'iframe', size: {x: 600, y: 400}}");

		return $button;
	}
}
